import { AfterViewInit, ChangeDetectorRef, EventEmitter, OnChanges, QueryList, SimpleChanges } from "@angular/core";
import { FormGroup } from "@angular/forms";
import { DynamicFormValidationService, DynamicFormControlModel, DynamicFormArrayGroupModel, DynamicFormControlComponent, DynamicFormControlEvent, DynamicTemplateDirective } from "@ng2-dynamic-forms/core";
export declare const enum BootstrapFormControlType {
    Array = 1,
    Checkbox = 2,
    Group = 3,
    Input = 4,
    RadioGroup = 5,
    Select = 6,
    TextArea = 7,
}
export declare class DynamicBootstrapFormControlComponent extends DynamicFormControlComponent implements AfterViewInit, OnChanges {
    protected changeDetectorRef: ChangeDetectorRef;
    protected validationService: DynamicFormValidationService;
    contentTemplates: QueryList<DynamicTemplateDirective>;
    inputTemplates: QueryList<DynamicTemplateDirective>;
    asBootstrapFormGroup: boolean;
    bindId: boolean;
    context: DynamicFormArrayGroupModel;
    group: FormGroup;
    hasErrorMessaging: boolean;
    model: DynamicFormControlModel;
    blur: EventEmitter<DynamicFormControlEvent>;
    change: EventEmitter<DynamicFormControlEvent>;
    focus: EventEmitter<DynamicFormControlEvent>;
    type: BootstrapFormControlType | null;
    constructor(changeDetectorRef: ChangeDetectorRef, validationService: DynamicFormValidationService);
    ngOnChanges(changes: SimpleChanges): void;
    static getFormControlType(model: DynamicFormControlModel): BootstrapFormControlType | null;
}
